/* Copyright (C)  Walter L. Peacock 1984-1988.  All rights reserved */
/* lockunlk.c  lock / unlock record using OS locking function. 11/06/87 */

/*----------------------------------------------------------------------------
 * lockunlk() is called by CBTREE as needed to effect record locking.
 * This is distributed as a stub function.  You will need to modify this
 * function to perform the type of locking supported by your particular
 * system.  Code provided below is for DOS 3.x locking with compiler support.
 * DOS 3.x users must install share.exe or share.com, or network software.
 *---------------------------------------------------------------------------*/

#include "cbtree.h"

#if XENIX
/* #include <sys/locking.h> */
#endif

#define LK_NBLCK 2
#define LK_UNLCK 0

#define LCKTRYS 800
#define LOCKOK 1
#define BUSY 0

		  /**************************************/
#if 1 	 /* change this to 0 to enable locking */
		/**************************************/

	/* dummy stub */
lockunlk() /* fd: file desc.; pos: relative byte location; */
{
	return(LOCKOK);
}

#else   /**************************************/

lockunlk(fd, pos, len, mode) /* fd: file desc.; pos: relative byte location; */
int fd;
long pos;
int len;					/* # bytes in lock region */
int mode;					/* read or write lock */
{
	int lockcnt = 0, lkret;
	long lseek();

	if (lseek(fd, pos, 0) == -1L)
		ckerror(- CK_SEEK, "82");

	if (mode == UNLOCKR) 		/* TURBO C use unlock() in place of locking. */
		lkret = locking(fd, LK_UNLCK, (long) len);   /* XENIX style call */
	else{
    	while(++lockcnt < LCKTRYS)	/* TURBO C use lock() in place of locking.*/
			if((lkret = locking(fd, LK_NBLCK, (long) len)) == 0)   /* XENIX style call */
				return(LOCKOK);
			else
         		delay(1L);

			/* total delay = LCKTRYS * delay; (800 * 0.01 = 8 seconds.) */

		return(BUSY);
	}
}

#endif	/**************************************/

